/*
 * guess.c - ɿ¬⥸塼
 *   Fri, Aug  8 1997 by Kouichi ABE (WALL)
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>

#include "kanji.h"
#include "wkf.h"

/*
 * ޥ
 */
#ifndef	CHECK_SIZE
#define	CHECK_SIZE	1024*2	/* ȽɤߥХåե	*/
#endif	/* CHECK_SIZE */

#define	S_TRUE		1
#define	S_FALSE		0

/*
 * ¤Τ
 */
typedef struct {		/* ɤ߹ѹ¤	*/
  char	buf[CHECK_SIZE];	/* ɤߥХåե	*/
  int	index;			/* Хåեؼ	*/
  int	size;			/* ɤ߹	*/
  FILE	*fp;			/* ե롦ݥ	*/
} CheckBuffer;

typedef struct {		/* ɹ¤		*/
  int	freq;			/* ɽи		*/
  int	point;			/* ɾݥ		*/
  int	ascii;			/* ASCII ɽи		*/
  int	kana;			/* Ⱦѥʽи		*/
  int	ctrl;			/* 楳ɽи		*/
  int	state;			/* Ƚܾ	*/
} KCode;

/*
 * ɽѿ
 */
static CheckBuffer	cb;

/*
 * ɽؿ
 */
static int		PreRead();
static KanjiCode	GuessKanjiCodeByCheckPoint();

/*
 * ؿ̾:	PreRead
 * ǽ:	Хåեɤ߹
 * :	ե롦ݥ
 * :	ɤ߹
 */
static int PreRead(fp)
	register FILE	*fp;
{
  cb.size  = fread(cb.buf, 1, CHECK_SIZE, fp);
  cb.index = 0;
  cb.fp	   = fp;

  return cb.size;
}

/*
 * ؿ̾:	NoPreRead
 * ǽ:	Хåեɤ߹ߤԤʤ
 * :	ե롦ݥ
 * :	ʤ
 */
void NoPreRead(fp)
	register FILE	*fp;
{
  cb.size  = cb.index = 0;
  cb.fp	   = fp;
}

/*
 * ؿ̾:	GetChar
 * ǽ:	ɤ߹ߥХåե or ե롦ݥ󥿤ʸɤ߽Ф
 * :	ʤ
 * :	int ʸ or EOF
 */
int GetChar(void)
{
  static Boolean	crlf = FALSE;
  int			c;

loop_getchar:
  if (cb.index < cb.size) {
    c = (u_char)cb.buf[cb.index++];
  }
  else {
    c = fgetc(cb.fp);
  }

  /* CR + LF or CR  LF Ѵ뤿λȤ	*/
  if (c == CR) {		/* CR ɤξ	*/
    crlf = TRUE;		/* ե饰ΩƤ	*/
    return LF;			/* LF ɤ֤	*/
  }

  if (crlf) {			/* ե饰ΩäƤ	*/
    crlf = FALSE;		/* ե饰򥯥ꥢ		*/
    if (c != LF) {		/* LF ɤǤʤʤ	*/
      return c;			/* Τޤ֤			*/
    }
    goto loop_getchar;		/* ʳϿɤ߹	*/
  }

  return c;
}

/*
 * ؿ̾:	UngetChar
 * ǽ:	ɤ߹ߥХåե or ե롦ݥ󥿤˰ʸ᤹
 * :	int ʸ
 * :	ʤ
 */
void UngetChar(c)
	register int	c;
{
  if (cb.index <= cb.size) {
    cb.index--;
    cb.buf[cb.index] = (char)c;
  }
  else {
    ungetc(c, cb.fp);
  }
}

/*
 * ؿ̾:	GuessKanjiCodeByCheckPoint
 * ǽ:	ξ硢åݥȤѤȽߤ
 * :	ƥɤδɹ¤
 * :	¬
 */
static KanjiCode GuessKanjiCodeByCheckPoint(ascii, jis, euc, sjis)
	KCode	*ascii, *jis, *euc, *sjis;
{
  KanjiCode	kcode = C_UNKNOWN;
  int		point = 0;

  if ((jis->point > point) && (jis->freq > 0) && (jis->point > jis->ctrl)) {
    point = jis->point;
    kcode = C_NEWJIS;
  }
  if ((euc->point > point) && (euc->freq > 0) && (euc->point > euc->ctrl)) {
    point = euc->point;
    kcode = C_EUC;
  }
  if ((sjis->point > point) && (sjis->freq > 0) && (sjis->point > sjis->ctrl)) {
    point = sjis->point;
    kcode = C_SJIS;
  }
#if	0
  if (kcode == C_UNKNOWN) {
    if ((ascii->point > point) && (ascii->freq > 0) &&
	(ascii->point > ascii->ctrl)) {
      kcode = C_ASCII;
    }
  }
#endif

  return kcode;
}

/*
 * ؿ̾:	GuessKanjiCode
 * ǽ:	ɤ¬
 * :	ϴɡϥե롦ݥ󥿡ϥե롦ݥ
 * :	¬
 */
KanjiCode GuessKanjiCode(kcode, in, out)
	KanjiCode	kcode;
	register FILE	*in, *out;
{
  KCode		ascii, jis, sjis, euc;
  KanjiCode	jis_code, ret_code;
  char		c;
  int		i;

  enum StateJIS { JS_START = 1, JS_ESC, JS_DOLLAR, JS_BRACKET_L, JS_JIS_1BYTE,
		  JS_JIS_2BYTE, JS_ASCII, JS_JISX0212_1990, JS_JIS7,
		  JS_JISX0208_1990_1, JS_JISX0208_1990_2 };
  enum StateEUC { ES_CS0 = 1, ES_CS1, ES_CS2, ES_CS3, ES_CS3_2 };
  enum StateSJIS { SS_1BYTE = 1, SS_2BYTE };

retry:
  (void)PreRead(in);	/* åѤɤ߹	*/

  /* Ƽѿ	*/
  ascii.state = jis.state   = sjis.state  = euc.state  = S_TRUE;
  ascii.freq  = ascii.point = ascii.ascii = ascii.kana = ascii.ctrl = 0;
  jis.freq    = jis.point   = jis.ascii   = jis.kana   = jis.ctrl   = 0;
  sjis.freq   = sjis.point  = sjis.ascii  = sjis.kana  = sjis.ctrl  = 0;
  euc.freq    = euc.point   = euc.ascii   = euc.kana   = euc.ctrl   = 0;
  jis_code    = C_NEWJIS;

  /* ɿ¬	*/
  for (i = 0; i < cb.size; i++) {
    c = cb.buf[i];	/* ɤ߹ߥХåեʸɤ߹	*/

    /* ASCII Ѿɽ	*/
    switch (ascii.state) {
      case 1:
	if (IsASCII(c)) {
	  ascii.freq++;
	  ascii.point ++;
	}
	else if (IsCTRL(c)) {
	  ascii.ctrl++;
	}
	else {
	  ascii.state = S_FALSE;
	}
	break;
    }

    /* JIS Ѿɽ	*/
    switch (jis.state) {
      case JS_START:	/* 	*/
	if (c == ESC) {			/* ס	*/
	  jis.state = JS_ESC;
	}
	else if (IsASCII(c)) {		/* ASCII 			*/
	  jis.ascii++;
	}
	else if (IsCTRL(c)) {		/* 楳			*/
	  jis.ctrl++;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_ESC:	/* ESC 	*/
	if (c == '$') {			/* Хʸβǽ		*/
	  jis.state = JS_DOLLAR;
	}
	else if (c == '(') {		/* Хʸβǽ		*/
	  jis.state = JS_BRACKET_L;
	}
	else if (c == '&') {		/* JIS X 0208-1990 βǽ	*/
	  jis.state = JS_JISX0208_1990_1;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_DOLLAR:	/* $ 	*/
	if (c == '@') {			/* JIS X 0208-1978 (JIS )	*/
	  jis.state = JS_JIS_1BYTE;
	  jis_code = C_OLDJIS;
	}
	else if (c == 'B') {		/* JIS X 0208-1983 (JIS )	*/
	  jis.state = JS_JIS_1BYTE;
	  jis_code = C_NEWJIS;
	}
	else if (c == '(') {		/* JIS X 0212-1990 βǽ	*/
	  jis.state = JS_JISX0212_1990;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_BRACKET_L:	/* ( 	*/
	if ((c == 'J') ||		/* JIS X 0201-1976 ޻	*/
	    (c == 'B')) {		/* ISO 646-1991 ASCII		*/
	  jis.state = JS_ASCII;
	}
	else if (c == 'I') {		/* JIX X 0201-1976 Ⱦѥ	*/
	  jis.state = JS_JIS7;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JIS_1BYTE:	/* JIS 裱Хʸ	*/
	if (c == ESC) {			/* ס	*/
	  jis.state = JS_ESC;
	}
	else if (IsJIS(c)) {		/* JIS 			*/
	  jis.state = JS_JIS_2BYTE;
	}
	else if (c == SO) {		/* JIS7 Ⱦѥʤβǽ	*/
	  jis.state = JS_JIS7;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JIS_2BYTE:	/* JIS 裲Хʸ	*/
	if (IsJIS(c)) {			/* JIS 			*/
	  jis.state = JS_JIS_1BYTE;
	  jis.freq++;
	  jis.point += 2;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_ASCII:	/* ASCII 	*/
	if (c == ESC) {			/* ס	*/
	  jis.state = JS_ESC;
	}
	else if (IsASCII(c)) {		/* ASCII 			*/
	  jis.ascii++;
	  jis.point += 2;
	}
	else if (IsCTRL(c)) {		/* 楳			*/
	  jis.ctrl++;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JISX0212_1990:	/* JIS X 0212-1990 	*/
	if (c == 'D') {			/* JIS X 0212-1990 βǽ	*/
	  jis.state = JS_JIS_1BYTE;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JIS7:	/* JIS7 	*/
	if (c == ESC) {			/* ס	*/
	  jis.state = JS_ESC;
	}
	else if (c == SI) {		/* JIS7 Ⱦѥʡ⡼ɽλ	*/
	  jis.state = JS_JIS_1BYTE;
	}
	else if (IsKANA7(c)) {		/* JIS7 			*/
	  jis.kana++;
	  jis.point += 2;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JISX0208_1990_1:	/* JIS X 0208-1990 Ͼ	*/
	if (c == '@') {			/* JIS X 0208-1990 βǽ	*/
	  jis.state = JS_JISX0208_1990_2;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
      case JS_JISX0208_1990_2:	/* JIS X 0208-1990 	*/
	if (c == ESC) {			/* ס	*/
	  jis.state = JS_ESC;
	  jis_code = C_JIS1990;
	}
	else {				/* JIS ɤʤ餷	*/
	  jis.state = S_FALSE;
	}
	break;
    }

    /* ܸ EUC ɾɽ	*/
    switch (euc.state) {
      case ES_CS0:	/* ɥåȣ	*/
	if (IsASCII(c)) {		/* ASCII 			*/
	  euc.ascii++;
	}
	else if (IsCTRL(c)) {		/* 楳			*/
	  euc.ctrl++;
	}
	else if (IsEUC((u_char)c)) {	/* ܸ EUC ɤβǽ	*/
	  euc.state = ES_CS1;
	}
	else if (c == SS2) {		/* ɥåȣβǽ	*/
	  euc.state = ES_CS2;
	}
	else if (c == SS3) {		/* ɥåȣβǽ	*/
	  euc.state = ES_CS3;
	}
	else {				/* EUC ɤʤ餷	*/
	  euc.state = S_FALSE;
	}
	break;
      case ES_CS1:	/* ɥåȣ	*/
	if (IsEUC((u_char)c)) {		/* ܸ EUC 		*/
	  euc.state = ES_CS0;
	  euc.freq++;
	  euc.point += 2;
	}
	else {				/* EUC ɤʤ餷	*/
	  euc.state = S_FALSE;
	}
	break;
      case ES_CS2:	/* ɥåȣ	*/
	if (IsKANA8((u_char)c)) {
	  euc.state = ES_CS0;
	  euc.kana++;
	  euc.point += 3;
	}
	else {				/* EUC ɤʤ餷	*/
	  euc.state = S_FALSE;
	}
	break;
      case ES_CS3:	/* ɥåȣ	*/
	if (IsEUC((u_char)c)) {		/* JIS X 0212-1990 βǽ	*/
	  euc.state = ES_CS3_2;
	}
	else {				/* EUC ɤʤ餷	*/
	  euc.state = S_FALSE;
	}
	break;
      case ES_CS3_2:	/* ɥåȣ	*/
	if (IsEUC((u_char)c)) {		/* JIS X 0212-1990 		*/
	  euc.state = ES_CS0;
	  euc.freq++;
	  euc.point += 3;
	}
	else {				/* EUC ɤʤ餷	*/
	  euc.state = S_FALSE;
	}
	break;
    }

    /* SJIS ɾɽ	*/
    switch (sjis.state) {
      case SS_1BYTE:	/* Хʸ	*/
	if (IsASCII(c)) {		/* ASCII 			*/
	  sjis.ascii++;
	}
	else if (IsCTRL(c)) {		/* 楳			*/
	  sjis.ctrl++;
	}
	else if (IsKANA8((u_char)c)) {	/* JIS8 			*/
	  sjis.kana++;
	  sjis.point++;
	}
	else if (IsSJIS1((u_char)c)) {	/* SJIS ɤβǽ		*/
	  sjis.state = SS_2BYTE;
	}
	else {				/* SJIS ɤʤ餷	*/
	  sjis.state = S_FALSE;
	}
	break;
      case SS_2BYTE:	/* Хʸ	*/
	if (IsSJIS2((u_char)c)) {	/* SJIS 			*/
	  sjis.state = SS_1BYTE;
	  sjis.freq++;
	  sjis.point += 2;
	}
	else {				/* SJIS ɤʤ餷	*/
	  sjis.state = S_FALSE;
	}
	break;
    }
  }

#ifdef	DEBUG
  (void)fprintf(stderr, "(%d)\tFREQ\tPOINT\tASCII\tKANA\tCTRL\tSTATE\n",
		cb.size);
  (void)fprintf(stderr, "ASCII:\t%d\t%d\t%d\t%d\t%d\t%d\n",
		ascii.freq, ascii.point, ascii.ascii, ascii.kana, ascii.ctrl,
		ascii.state);
  (void)fprintf(stderr, "JIS:\t%d\t%d\t%d\t%d\t%d\t%d\n",
		jis.freq, jis.point, jis.ascii, jis.kana, jis.ctrl, jis.state);
  (void)fprintf(stderr, "SJIS:\t%d\t%d\t%d\t%d\t%d\t%d\n",
		sjis.freq, sjis.point, sjis.ascii, sjis.kana, sjis.ctrl,
		sjis.state);
  (void)fprintf(stderr, "EUC:\t%d\t%d\t%d\t%d\t%d\t%d\n",
		euc.freq, euc.point, euc.ascii, euc.kana, euc.ctrl, euc.state);
#endif	/* DEBUG */

  /* Ƚ	*/
#if	0
  if ((!ascii.freq && !jis.freq && !euc.freq && !sjis.freq) ||
      (!ascii.state && !jis.state && !euc.state && !sjis.state)) {
    KanjiCode	ret = GuessKanjiCodeByCheckPoint(&ascii, &jis, &euc, &sjis);
    if (ret == C_NEWJIS) {
      return jis_code;
    }
    return ret;
  }
#endif

  /* ASCII ɤ餷	*/
  if (ascii.state * jis.state * euc.state * sjis.state == 1) {
    if (cb.size == CHECK_SIZE) {	/* ⤦Ĵ٤Ƥߤ褦	*/
      if (kcode != C_UNKNOWN) {	/* Ѵξϥե˽	*/
	fwrite(cb.buf, 1, (size_t)cb.size, out);
      }
      goto retry;		/* ⤦ٴɤĴ٤Ƥߤ	*/
    }
    else {					/* ASCII ɤȽ	*/
      return ascii.freq ? C_ASCII : C_UNKNOWN;
    }
  }

  if (euc.point && sjis.point &&
       euc.state && sjis.state) {
#if	0
  if (euc.state && sjis.state) {	/* ܸ EUC or SJIS 	*/
#endif
    if (euc.point > sjis.point) {		/* ܸ EUC 	*/
      return C_EUC;
    }
    else if (sjis.point > euc.point) {		/* Shift-JIS 	*/
      return C_SJIS;
    }
    else {			/* euc.point  sjis.point 	*/
      if (euc.freq > sjis.freq) {		/* ܸ EUC 	*/
	return C_EUC;
      }
      else if (sjis.freq > euc.freq) {		/* Shift-JIS 	*/
	return C_SJIS;
      }
      else {			/* ܸ EUC  Shift-JIS 	*/
	if (!jis.freq && !euc.freq && !sjis.freq) {	/* ASCII 	*/
	  return C_ASCII;
	}
	if (jis.state && jis.freq) {	/* JIS(졦1990) 	*/
	  return jis_code;
	}
	return C_EUCorSJIS;
      }
    }
  }
  else {
    if (euc.state && euc.point) {		/* ܸ EUC 	*/
      return C_EUC;
    }
    if (sjis.state && sjis.point) {		/* Shift-JIS 	*/
      return C_SJIS;
    }
  }

#if	0
  if (!jis.freq && !euc.freq && !sjis.freq) {		/* ASCII 	*/
    return C_ASCII;
  }
#endif

  if (jis.state && jis.point) {		/* JIS(졦1990) 	*/
    return jis_code;
  }

  /*
   * ܲǤޤʥɤäƤˡ
   * ޤɤȽ̤Ԥʤ礬롣
   * ǤϡäؤʤΤǴɤ٤ȥݥȤ
   * Ƚ̤ԤäƤߤ롣
   * ⤷顢ǥХǽ(^^;)
   */
#if	1
  if ((!ascii.freq && !jis.freq && !euc.freq && !sjis.freq) ||
      (!ascii.state && !jis.state && !euc.state && !sjis.state)) {
    KanjiCode	ret = GuessKanjiCodeByCheckPoint(&ascii, &jis, &euc, &sjis);
    if (ret == C_NEWJIS) {
      return jis_code;
    }
    return ret;
  }
  
  return C_UNKNOWN;
#else	/* äΥ롼Ƚ̤(¿Υߤ̵뤹)	*/
  ret_code = GuessKanjiCodeByCheckPoint(&ascii, &jis, &euc, &sjis);
  if (ret_code == C_NEWJIS) {
    return jis_code;
  }
  return ret_code;
#endif
}

#ifdef	DEBUG_GUESS
int main(argc, argv)
	int	argc;
	char	**argv;
{
  register FILE	*fp;
  register int	i;

  if (argc == 1) {
    (void)fprintf(stderr, "usage: %s file\n", *argv);
    exit(1);
  }
  
  for (i = 1; i < argc; i++) {
    fp = fopen(argv[i], "r");
    if (fp == NULL) {
      (void)fprintf(stderr, "can't open %s\n", argv[i]);
      continue;
    }
    (void)fprintf(stderr, "\n[%s]\n", argv[i]);
    switch (GuessKanjiCode(fp)) {
      case C_UNKNOWN:
	(void)fprintf(stderr, "unknown\n");
	break;
      case C_EUCorSJIS:
	(void)fprintf(stderr, "euc or sjis\n");
	break;
      case C_ASCII:
	(void)fprintf(stderr, "ascii\n");
	break;
      case C_OLDJIS:
	(void)fprintf(stderr, "oldjis\n");
	break;
      case C_NEWJIS:
	(void)fprintf(stderr, "newjis\n");
	break;
      case C_JIS1990:
	(void)fprintf(stderr, "jis1990\n");
	break;
      case C_EUC:
	(void)fprintf(stderr, "euc\n");
	break;
      case C_SJIS:
	(void)fprintf(stderr, "sjis\n");
	break;
      default:
	break;
    }
    (void)fclose(fp);
  }

  return 0;
}
#endif	/* DEBUG_GUESS */
