/*
 * kanji.h - ѥإå
 *    Wed, Aug  6 1997 by Kouichi ABE (WALL)
 */
#ifndef	_kanji_h
#define	_kanji_h	1

/*
 * ޥ
 */
typedef enum {
  C_UNKNOWN = -1,	/* 		*/
  C_EUCorSJIS,		/* EUC  SJIS 	*/
  C_ASCII,		/* ASCII 		*/
  C_OLDJIS,		/*  JIS 	*/
  C_NEWJIS,		/*  JIS 	*/
  C_JIS1990,		/* 1990  JIS 	*/
  C_SJIS,		/* Shift-JIS 	*/
  C_EUC			/* ܸ EUC 	*/
} KanjiCode;

#ifndef	_BOOLEAN
#define	_BOOLEAN
#ifdef	FALSE
#undef	FALSE
#endif	/* FALSE */
#ifdef	TRUE
#undef	TRUE
#endif	/* TRUE */
typedef enum { FALSE, TRUE } Boolean;
#endif	/* _BOOLEAN */

#define	EOL		'\0'		/* ʸü		*/
#define	LF		'\n'		/* (0A)			*/
#define	CR		'\r'		/* (0D)			*/

#define	SPC		'\040'		/* (1F)			*/
#define	BS		'\010'		/* (08)			*/
#define	DEL		'\0177'		/* (7F)			*/

#define	ESC		'\033'		/* JIS Escape Sequence (1B)	*/
#define	SO		'\016'		/* JIS Shift-Out (0E)		*/
#define	SI		'\017'		/* JIS Shift-In  (0F)		*/

#define	SS2		'\216'		/* EUC Single Shift 2 (8E)	*/
#define	SS3		'\217'		/* EUC Single Shift 3 (8F)	*/

#define	ES_OLDJIS	"\033$@"	/* JIS X 0208-1978 (JIS )	*/
#define	ES_NEWJIS	"\033$B"	/* JIS X 0208-1983 (JIS )	*/
#define	ES_JIS1990	"\033&@\033$B"	/* JIS X 0208-1990		*/
#define	ES_JISX02121990	"\033$(D"	/* JIS X 0212-1990 ()	*/
#define	ES_JISROMA	"\033(J"	/* JIS X 0201-1976 (޻)	*/
#define	ES_ASCII	"\033(B"	/* ISO 646-1991	ASCII		*/
#define	ES_JISKANA	"\033(I"	/* JIS X 0201-1976 (Ⱦѥ)	*/

#define	IsCTRL(c)	((((c) >= 0x00 && (c) <= 0x1f) || (c) == 0x7f) ? 1 : 0)
#define	IsASCII(c)	(((c) >= 0x20 && (c) <= 0x7e) ? 1 : 0)
#define	IsJIS(c)	(((c) >= 0x21 && (c) <= 0x7e) ? 1 : 0)
#define	IsSJIS1(c)	((((c) >= 0x81 && (c) <= 0x9f) || \
			  ((c) >= 0xe0 && (c) <= 0xef)) ? 1 : 0)
#define	IsSJIS2(c)	((((c) >= 0x40 && (c) <= 0x7e) || \
			  ((c) >= 0x80 && (c) <= 0xfc)) ? 1 : 0)
#define	IsEUC(c)	(((c) >= 0xa1 && (c) <= 0xfe) ? 1 : 0)
#define	IsKANA7(c)	(((c) >= 0x21 && (c) <= 0x5f) ? 1 : 0)
#define	IsKANA8(c)	(((c) >= 0xa1 && (c) <= 0xdf) ? 1 : 0)

#endif	/* _kanji_h */
